import { world, system, EntityEquippableComponent, EquipmentSlot, ItemStack} from "@minecraft/server";
let dimesion = world.getDimension("overworld");
let players = world.getPlayers({excludeGameModes:['spectator']});




world.afterEvents.playerSpawn.subscribe(({player}) => {
    updatePlayers();
  
});



world.beforeEvents.playerLeave.subscribe(({}) => {
    updatePlayers();
});


  //Icons

    const handSymbolMap = {
        0: "", 1: "", 2: "", 3: "",
        4: "", 5: "", 6: ""
    
    };

    const swordSymbolMap = {
    0: "", 1: "", 2: "", 3: "", 4: "", 5: "", 6: "",
    7: "", 8: "", 9: "", 10: "", 11: ""};
  

    const axeSymbolMap = {
    0: "", 1: "", 2: "", 3: "", 4: "", 5: "", 6: "",
    7: "", 8: "", 9: "", 10: "", 11: "", 12: "", 13: "", 14: "",
    15: "", 16: "", 17: "", 18: "", 19: "", 20: "",
    21: ""};

    const toolSymbolMap = {
        0: "", 1: "", 2: "", 3: "", 4: "", 5: "", 6: "",
        7: "", 8: "", 9: "", 10: "", 11: "", 12: "", 13: "", 14: "",
        15: "", 16: "", 17: "", 18: "", 19: "", 20: "",
        21: ""};

        const playerLastView = new Map();


system.runInterval(() => {
    players.forEach(player => {
        const view = player.getEntitiesFromViewDirection({ maxDistance: 3 });
        const lastViewedEntity = playerLastView.get(player.id);
        if (view[0]) {
            playerLastView.set(player.id, true);
        } else if (lastViewedEntity) {
            playerLastView.set(player.id, false);
        }
       //


        //Equipment
        const playerEquipment = player.getComponent(EntityEquippableComponent.componentId);
        const mainHandItem = playerEquipment.getEquipment(EquipmentSlot.Mainhand);
        const offHandItem = playerEquipment.getEquipment(EquipmentSlot.Offhand);

        
        const itemType = 

        offHandItem?.typeId === "minecraft:shield" ? null :
        mainHandItem?.typeId === "minecraft:shield" ? 'raiyon:shield' :
        mainHandItem?.typeId === "minecraft:wooden_axe" ? 'raiyon:wooden_axe' :
        mainHandItem?.typeId === "minecraft:stone_axe" ? 'raiyon:stone_axe' :
        mainHandItem?.typeId === "minecraft:iron_axe" ? 'raiyon:iron_axe' :
        mainHandItem?.typeId === "minecraft:diamond_axe" ? 'raiyon:diamond_axe' :
        mainHandItem?.typeId === "minecraft:netherite_axe" ? 'raiyon:netherite_axe' :
        mainHandItem?.typeId === "minecraft:golden_axe" ? 'raiyon:golden_axe' : undefined;

        if(itemType !== undefined){
        let hand = itemType === null ? offHandItem : mainHandItem;
        const enchantments = hand.getComponent('enchantable');
        const enchantmentsList = enchantments.getEnchantments();
        const newStack = new ItemStack(itemType === null ? 'raiyon:shield' : itemType ,1);
        
        const Durability = hand.getComponent('minecraft:durability');

        enchantmentsList.forEach(enchant => {
        const newEnchantments = newStack.getComponent('enchantable');
        newEnchantments.addEnchantment({level:enchant.level,type:enchant.type});
        });
        const newDurability = newStack.getComponent('durability');
        newDurability.damage = Durability.damage;

        if(!newDurability) return;

        let handSlot = itemType === null ? EquipmentSlot.Offhand : EquipmentSlot.Mainhand;
        playerEquipment.setEquipment(handSlot,newStack);
    
    
    }
        const toolScoreboard = player.getDynamicProperty('tool:scoreboard');
        const handScoreboard = player.getDynamicProperty('hand:scoreboard');
        const swordScoreboard = player.getDynamicProperty('sword:scoreboard');
        const axeScoreboard = player.getDynamicProperty('axe:scoreboard');
        let selectIcon = view[0] ? "" : "\n" ;
        //Icon
        let handSymbol = handSymbolMap[handScoreboard] || selectIcon;
        let toolSymbol = toolSymbolMap[toolScoreboard] || selectIcon ;
        let swordSymbol = swordSymbolMap[swordScoreboard] || selectIcon;
        let axeSymbol = axeSymbolMap[axeScoreboard] || selectIcon;

        if(handScoreboard === undefined){

            player.setDynamicProperty('hand:scoreboard',0);
        }

        if(swordScoreboard === undefined){

            player.setDynamicProperty('sword:scoreboard',0);
        }

        if(axeScoreboard === undefined){

            player.setDynamicProperty('axe:scoreboard',0);
        }

        //Tools
        if(mainHandItem?.typeId.includes("pickaxe") ||
        mainHandItem?.typeId.includes("shovel") ||
        mainHandItem?.typeId.includes("hoe") || 
        mainHandItem?.typeId.includes("trident")){
        updateAttackTimeTags(player, 'tool', toolScoreboard);
        player.onScreenDisplay.setActionBar({ text: toolSymbol });
        player.setDynamicProperty('tool:scoreboard',toolScoreboard + 1);
        } else{

        player.setDynamicProperty('tool:scoreboard',0);
        }

        //Hand
        if(!mainHandItem || (!mainHandItem?.typeId.includes("axe") &&
        !mainHandItem?.typeId.includes("sword") &&
        !mainHandItem?.typeId.includes("trident") &&
        !mainHandItem?.typeId.includes("shovel") &&
        !mainHandItem?.typeId.includes("hoe"))){
            player.addTag("hand");
            player.onScreenDisplay.setActionBar({ text: handSymbol });
        if(handScoreboard < 8){
            player.setDynamicProperty('hand:scoreboard',handScoreboard +1);
        }
        } else {
        player.removeTag("hand");
        player.setDynamicProperty('hand:scoreboard',0);}

        //Sword
        if (mainHandItem?.typeId.includes("sword")) {
            player.onScreenDisplay.setActionBar({ text: swordSymbol });
            updateAttackTimeTags(player, 'sword', swordScoreboard);
            if (swordScoreboard < 12) {
                player.setDynamicProperty('sword:scoreboard', swordScoreboard + 1);
            }
            else {
            }
        } else {
            if(swordScoreboard !== 0){
            player.setDynamicProperty('sword:scoreboard', 0);}
        }


        //Axe
        if (mainHandItem?.typeId.includes("_axe")) {
         


            player.onScreenDisplay.setActionBar({ text: axeSymbol });

          
            updateAttackTimeTags(player, 'axe', axeScoreboard);
            //Axe Scoreboard Increase
            if (axeScoreboard < 22) {
                player.setDynamicProperty('axe:scoreboard', axeScoreboard + 1);
            }

            //Not Axe
        } else {
            

          
            if(axeScoreboard !== 0){
            player.setDynamicProperty('axe:scoreboard', 0);}
        }
        //Sprint
        const sprintProperty = player.getDynamicProperty('raiyon:sprint');
        if (player.isSprinting && swordScoreboard >= 10 || player.isSprinting && axeScoreboard >= 18) {
            if (sprintProperty !== 0) {
                player.setDynamicProperty('raiyon:sprint', 0);
            }
           
        } else {
            if (sprintProperty < 10) {
                player.setDynamicProperty('raiyon:sprint', sprintProperty + 1);
            }
        }
        //Jump
        const jumpProperty = player.getDynamicProperty('raiyon:jump');
        if (player.isJumping) {
            player.setDynamicProperty('raiyon:jump', 0);
            player.triggerEvent("raiyon:kb_resistance_jumping");
        } else {
            if (jumpProperty < 6) {

                player.setDynamicProperty('raiyon:jump', jumpProperty + 1);
            }

            if (jumpProperty >= 6) {
                player.triggerEvent("raiyon:kb_resistance_normal");
            }
        }

        //Shield
        const shieldProperty = player.getDynamicProperty('raiyon:shield');
        if (player.hasTag("raiyon:shieldc")) {
            if (shieldProperty < 3) {
                if(player.hasTag("raiyon:shield")){
                player.removeTag("raiyon:shield");}

                player.setDynamicProperty('raiyon:shield', shieldProperty + 1);
            }
            if (shieldProperty >= 3) {
                if(!player.hasTag("raiyon:shield")){
                player.addTag("raiyon:shield");}
            }
        } else {
            if(shieldProperty !== 0){
            player.setDynamicProperty('raiyon:shield', 0);}
        }
        //Blocking Shield
        const shieldBlocking = player.getDynamicProperty('raiyon:blocking_shield');
        if(player.hasTag("raiyon:blocking_shield")){
            if (shieldBlocking === undefined) {
                player.setDynamicProperty('raiyon:blocking_shield', 0);
            } else{
            if(shieldBlocking === 1){
                player.runCommand(`playsound random.break @a[r=5] ~ ~ ~ 1 0.8`);
            }
            if(shieldBlocking >= 100){
                if(player.hasTag("raiyon:blocking_shield")){
                player.removeTag("raiyon:blocking_shield");}
                if(shieldBlocking !== 0){
                player.setDynamicProperty('raiyon:blocking_shield', 0);}
                player.triggerEvent("raiyon:enable_shield");

            } else{
                player.triggerEvent("raiyon:disable_shield");
                player.setDynamicProperty('raiyon:blocking_shield', shieldBlocking + 1);
            }
        }
    }
             
          
});
  


})

system.runInterval(() => {

    players.forEach(player => {

    if(!player.hasTag("raiyon:shield")) return;
        const entityTest = dimesion.getEntities({maxDistance:20,excludeTypes:["minecraft:item"],location:player.location});
        entityTest.forEach(entity => {
            const viewDirection = entity.getViewDirection();
            let directionTag;
            const angle = Math.atan2(viewDirection.x, viewDirection.z) * (180 / Math.PI);
    
            const normalizedAngle = (angle + 360) % 360;
    
            const angleRange = 45; 
            
            if (normalizedAngle >= 0 && normalizedAngle < angleRange) {
                directionTag = 'South';
            
            } else if (normalizedAngle >= angleRange * 2 && normalizedAngle < angleRange * 3) {
                directionTag = 'West';
           
            } else if (normalizedAngle >= angleRange * 4 && normalizedAngle < angleRange * 5) {
                directionTag = 'North';
           
            } else if (normalizedAngle >= angleRange * 6 && normalizedAngle < angleRange * 7) {
                directionTag = 'East';
           
            } 
        
            if (directionTag) {
                entity.addTag(directionTag);
        
                const directions = ['North',  'East',  'South',  'West'];
                directions.forEach(tag => {
                
                if(tag !== directionTag){
                entity.removeTag(tag);
                }
              
                });
                }

                const entityTags = entity.getTags(); 
                const playerTags = player.getTags(); 

                const tagsToCheck = ['North', 'East', 'South', 'West'];

                const commonTags = entityTags.filter(tag => playerTags.includes(tag) && tagsToCheck.includes(tag));
        
                if (commonTags.length > 0) {
                  entity.addTag("behind");
                  entity.removeTag("front");


                } else{

                    entity.addTag("front");
                    entity.removeTag("behind");
                    }
                });
    })


    let damagedEntities = dimesion.getEntities(({ tags: ["raiyon:cooldown_damage"]}))
    damagedEntities.forEach(entity => {
      
            
        const damagedCooldown = entity.getDynamicProperty('damaged_cooldown');
        if (damagedCooldown === undefined) {

            entity.setDynamicProperty('damaged_cooldown', 0);
        } else {
            entity.setDynamicProperty('damaged_cooldown', damagedCooldown + 1);
            if (damagedCooldown >= 1) {
                entity.removeTag("raiyon:cooldown_damage");
                entity.setDynamicProperty('damaged_cooldown', undefined);
            }
        }
    });  
},4);

world.afterEvents.entityHurt.subscribe(({ hurtEntity, damageSource, damage }) => {
    const damagingEntity = damageSource.damagingEntity;
    const isPlayerDamaging = damagingEntity && damagingEntity.typeId === "minecraft:player";
    const isPlayerHurt = hurtEntity.typeId === 'minecraft:player';
    const swordScoreboard = isPlayerDamaging && damagingEntity.getDynamicProperty('sword:scoreboard');
    const axeScoreboard = isPlayerDamaging && damagingEntity.getDynamicProperty('axe:scoreboard');
    const sprintProperty = isPlayerDamaging && damagingEntity.getDynamicProperty('raiyon:sprint');

    


    if (damagingEntity && isPlayerHurt && damagingEntity.typeId === 'minecraft:husk'){

        hurtEntity.addEffect("hunger",600);
    }

    if (damagingEntity && isPlayerHurt && damagingEntity.typeId === 'minecraft:cave_spider'){
        if(damagingEntity.hasTag("raiyon:n")){
        hurtEntity.addEffect("poison",140);}

        if(damagingEntity.hasTag("raiyon:h")){
            hurtEntity.addEffect("poison",300);}

    }

    if (isPlayerHurt && damagingEntity && damagingEntity.typeId === 'minecraft:wither_skeleton'){

        hurtEntity.addEffect("wither",200);
    }
    

    if (isPlayerDamaging && !damageSource.damagingProjectile) {
        hurtEntity.addTag("raiyon:cooldown_damage",);
    }

    if (isPlayerDamaging) {
        if (!damagingEntity.isFalling && sprintProperty < 10) {
            damagingEntity.runCommand('playsound knockback @a[r=5]');
            const { x: directionX, z: directionZ } = damagingEntity.getViewDirection();
            hurtEntity.applyKnockback(directionX, directionZ, 1.1, 0.45);
        }

        if (sprintProperty >= 10 && damagingEntity.isOnGround && !damagingEntity.isFalling && swordScoreboard >= 12) {
            damagingEntity.runCommand(`function java_combat/sweep`);
        }
        if (damagingEntity.isFalling && !damagingEntity.isOnGround && swordScoreboard >= 9 || damagingEntity.isFalling && !damagingEntity.isOnGround && axeScoreboard >= 18) {
            damagingEntity.runCommand('playsound critical_hit @a[r=5]');
            const damageInt = Math.floor(damage);
            for (let i = 0; i < damageInt; i += 2) {
                hurtEntity.dimension.spawnParticle("raiyon:critical_hit", hurtEntity.location);
            }
        }

        if (damagingEntity.hasTag("raiyon:enchanted_hit")) {
            hurtEntity.dimension.spawnParticle("raiyon:enchanted_hit", hurtEntity.location);
        }
    }

    if (isPlayerHurt && damageSource.damagingProjectile && isPlayerDamaging) {
        damagingEntity.playSound("random.orb");
    }
});

world.afterEvents.playerInteractWithBlock.subscribe(({block,player,itemStack}) => {

        if(block.typeId === 'minecraft:web' && itemStack.typeId === 'minecraft:water_bucket'){

            player.dimension.fillBlocks(block.location,block.location,"minecraft:air");
        }
    });
   
world.afterEvents.entityHitEntity.subscribe(({damagingEntity,hitEntity}) => {
    if(damagingEntity.typeId === 'minecraft:player'){
    
    set_0_damaging(damagingEntity);}

    const getAxeEntity = damagingEntity.runCommand('execute as @s[hasitem={item=raiyon:wooden_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 : 
    damagingEntity.runCommand('execute as @s[hasitem={item=raiyon:stone_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 :
    damagingEntity.runCommand('execute as @s[hasitem={item=raiyon:iron_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 :
    damagingEntity.runCommand('execute as @s[hasitem={item=raiyon:netherite_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 :
    damagingEntity.runCommand('execute as @s[hasitem={item=raiyon:diamond_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 :
    damagingEntity.runCommand('execute as @s[hasitem={item=raiyon:golden_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 :

    damagingEntity.runCommand('execute as @s[hasitem={item=minecraft:golden_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 : 
    damagingEntity.runCommand('execute as @s[hasitem={item=minecraft:wooden_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 : 
    damagingEntity.runCommand('execute as @s[hasitem={item=minecraft:stone_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 :
    damagingEntity.runCommand('execute as @s[hasitem={item=minecraft:iron_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 :
    damagingEntity.runCommand('execute as @s[hasitem={item=minecraft:netherite_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 :
    damagingEntity.runCommand('execute as @s[hasitem={item=minecraft:diamond_axe,location=slot.weapon.mainhand}] run effect @s hunger 0 0 true').successCount > 0 ? 1 : 0;
    if(damagingEntity.typeId !== 'minecraft:player'  && hitEntity.hasTag("raiyon:shield") && getAxeEntity === 1){

        hitEntity.addTag('raiyon:blocking_shield');
    }


});

   
world.afterEvents.entityHitBlock.subscribe(({damagingEntity}) => {
    if(damagingEntity.typeId === 'minecraft:player'){
    set_0_damaging(damagingEntity);

}

});

world.afterEvents.projectileHitEntity.subscribe(event => {
  

    if (event.projectile.isValid && event.projectile.typeId === 'minecraft:arrow') {
        event.projectile.remove();      
    }
});

//Crossbow

world.beforeEvents.itemUse.subscribe(({source,itemStack}) => {

    system.run(() => {
        if(source.hasTag("raiyon:shield") && itemStack.typeId.includes("crossbow"))
        {source.playAnimation("animation.player.crossbow_hold",{blendOutTime:0});}
    })
});

world.beforeEvents.dataDrivenEntityTriggerEvent.subscribe(({entity,id}) => {
    system.run(() => {
    if(id === 'raiyon:take_shield_durability'){
    entity.runCommand('playsound item.shield.block @a[r=5] ~ ~ ~ 1 0.8');
    const equipment = entity.getComponent('minecraft:equippable');
    if (!equipment) return;
    const itemInMainhand = equipment.getEquipment(EquipmentSlot.Mainhand);
    const itemInOffhand = equipment.getEquipment(EquipmentSlot.Offhand);
    if (itemInMainhand?.typeId?.endsWith('shield')) {
        updateShieldDurability(itemInMainhand, equipment, EquipmentSlot.Mainhand, entity);
    } else if (itemInOffhand?.typeId?.endsWith('shield')) {
        updateShieldDurability(itemInOffhand, equipment, EquipmentSlot.Offhand, entity);
    }}

    if(id === 'raiyon:disabled_shield')
    {entity.addTag('raiyon:blocking_shield');}

    if(id === 'raiyon:cooldown_damage')
    {entity.addTag('cooldown_damage');}

    if(id === 'raiyon:set_0')
    {
        const equipment = entity.getComponent('minecraft:equippable');

        const itemInMainhand = equipment.getEquipment(EquipmentSlot.Mainhand);

        
        set_0_entity(entity);
    if(itemInMainhand?.typeId === 'minecraft:trident'){

        entity.setDynamicProperty('tool:scoreboard',0);
    }
    
    }

    })
});


function updateShieldDurability(item, equipment, slot, entity) {
    const durability = item.getComponent('minecraft:durability');
    if (!durability) return;

    durability.damage++;
    equipment.setEquipment(slot, item);

    if (durability.damage >= durability.maxDurability) {
        entity.playSound('random.break');
        equipment.setEquipment(slot);
    }
}


function set_0_entity(entity) {
    entity.setDynamicProperty('hand:scoreboard',0);
    entity.setDynamicProperty('axe:scoreboard', 0);
    entity.setDynamicProperty('sword:scoreboard', 0);
}



function set_0_damaging(damagingEntity) {
    system.runTimeout(() => {
    damagingEntity.setDynamicProperty('tool:scoreboard',0);
    damagingEntity.setDynamicProperty('hand:scoreboard',0);
    damagingEntity.setDynamicProperty('axe:scoreboard', 0);
    damagingEntity.setDynamicProperty('sword:scoreboard', 0);
}, 1)}

function updateAttackTimeTags(player, weapon, bar) {
    const thresholds = {
        'tool': [0, 6, 6, 10, 15, 15, 20, 20, 20, 22],
        'sword': [0, 5, 6, 7, 8, 9, 10, 11, 12, 12],
        'axe': [0, 6, 6, 10, 15, 15, 20, 20, 20, 22]
    };

    for (let i = 0; i <= 9; i++) {
        player.removeTag(`v_${i}`);
    }

    const barThresholds = thresholds[weapon];
    let tagAdded = false;
    for (let i = barThresholds.length - 1; i >= 0; i--) {
        if (bar >= barThresholds[i]) {
            player.addTag(`v_${i}`);
            tagAdded = true;
            break;
        }
    }

    if (!tagAdded && bar < barThresholds[0]) {
        player.addTag('v_0');
    }
}

function updatePlayers() {
   
    system.runTimeout(() => {
        players = world.getPlayers({excludeGameModes:['spectator']});
    }, 20)
}